library(faraway)
data(gala, package="faraway")
lmod <- lm(Species ~ Area + Elevation + Nearest + Scruz  + Adjacent, gala)
sumary(lmod)
sumary(lm(Species ~ Elevation, gala))
plot(Species ~ Elevation, gala)
abline(11.3,0.201)
colMeans(gala)
p <- predict(lmod, data.frame(Area=261.7, Elevation=gala$Elevation, Nearest=10.06, Scruz = 56.98, Adjacent=261.1))
i <- order(gala$Elevation)
lines(gala$Elevation[i], p[i], lty=2)
data(newhamp, package="faraway")
colSums(newhamp[newhamp$votesys == 'D',2:3])
colSums(newhamp[newhamp$votesys == 'H',2:3])
newhamp$trt <- ifelse(newhamp$votesys == 'H',1,0)
lmodu <- lm(pObama ~ trt, newhamp)
sumary(lmodu)
lmodz <- lm(pObama ~ trt +  Dean , newhamp)
sumary(lmodz)
sumary(lm(Dean ~ trt, newhamp))
require(Matching)
set.seed(123)
mm <- GenMatch(newhamp$trt, newhamp$Dean, ties=FALSE, caliper=0.05, pop.size=1000)
head(mm$matches[,1:2])
newhamp[c(4,218),c('Dean','pObama','trt')]
plot(pObama ~ Dean, newhamp, pch=trt+1)
with(newhamp,segments(Dean[mm$match[,1]],pObama[mm$match[,1]],Dean[mm$match[,2]],pObama[mm$match[,2]]))
pdiff <- newhamp$pObama[mm$matches[,1]] - newhamp$pObama[mm$matches[,2]]
t.test(pdiff)
plot(pdiff ~ newhamp$Dean[mm$matches[,1]], xlab="Dean", ylab="Hand-Digital")
abline(h=0)
plot(pObama ~ Dean, newhamp, pch=trt+1)
abline(h=c(.353, 0.353+0.042),lty=1:2)
abline(0.221, 0.5229)
abline(0.221-0.005, 0.5229, lty=2)
with(newhamp,segments(Dean[mm$match[,1]],pObama[mm$match[,1]],Dean[mm$match[,2]],pObama[mm$match[,2]],col=gray(0.75)))
