library(faraway)
data(sexab,package="faraway")
sexab
by(sexab,sexab$csa,summary)
plot(ptsd ~ csa, sexab)
plot(ptsd ~ cpa, pch=as.character(csa), sexab)
t.test(ptsd ~ csa, sexab, var.equal=TRUE)
d1 <- ifelse(sexab$csa == "Abused",1,0)
d2 <- ifelse(sexab$csa == "NotAbused",1,0)
lmod <- lm(ptsd ~ d1 + d2, sexab)
sumary(lmod)
model.matrix(lmod)
lmod <- lm(ptsd ~ d2, sexab)
sumary(lmod)
lmod <- lm(ptsd ~ d1 + d2 -1, sexab)
sumary(lmod)
lmod <- lm(ptsd ~ csa, sexab)
sumary(lmod)
class(sexab$csa)
sexab$csa <- relevel(sexab$csa, ref="NotAbused")
lmod <- lm(ptsd ~ csa, sexab)
sumary(lmod)
lmod4 <- lm(ptsd ~ cpa+csa+cpa:csa,sexab)
sumary(lmod4)
model.matrix(lmod4)
plot(ptsd ~ cpa, sexab, pch=as.numeric(csa))
abline(3.96, 0.764)
abline(3.96+6.86, 0.764-0.314,lty=2)
lmod3 <- lm(ptsd ~ cpa+csa,sexab)
sumary(lmod3)
plot(ptsd ~ cpa, sexab, pch=as.numeric(csa))
abline(3.98, 0.551)
abline(3.98+6.27, 0.551, lty=2)
confint(lmod3)[3,]
plot(fitted(lmod3),residuals(lmod3),pch=as.numeric(sexab$csa),  xlab="Fitted",ylab="Residuals")
lmod1 <- lm(ptsd ~ cpa,sexab)
sumary(lmod1)
data(whiteside,package="MASS")
require(ggplot2)
ggplot(aes(x=Temp,y=Gas),data=whiteside)+geom_point()+facet_grid(~ Insul)+geom_smooth(method="lm")
lmod <- lm(Gas ~ Temp*Insul, whiteside)
sumary(lmod)
mean(whiteside$Temp)
whiteside$ctemp <- whiteside$Temp - mean(whiteside$Temp)
lmodc <- lm(Gas ~ ctemp*Insul, whiteside)
sumary(lmodc)
data(fruitfly,package="faraway")
plot(longevity ~ thorax, fruitfly, pch=unclass(activity))
legend(0.63,100,levels(fruitfly$activity),pch=1:5)
require(ggplot2)
ggplot(aes(x=thorax,y=longevity),data=fruitfly) + geom_point() + facet_wrap( ~ activity)
lmod <- lm(longevity ~ thorax*activity, fruitfly)
sumary(lmod)
model.matrix(lmod)
plot(lmod)
anova(lmod)
lmodp <- lm(longevity ~ thorax+activity, fruitfly)
drop1(lmodp,test="F")
sumary(lmodp)
plot(residuals(lmodp) ~fitted(lmodp),pch=unclass(fruitfly$activity),  xlab="Fitted",ylab="Residuals")
abline(h=0)
lmodl <- lm(log(longevity) ~ thorax+activity, fruitfly)
plot(residuals(lmodl) ~ fitted(lmodl),pch=unclass(fruitfly$activity), xlab="Fitted",ylab="Residuals")
abline(h=0)
sumary(lmodl)
exp(coef(lmodl)[3:6])
lmodh <- lm(thorax ~ activity, fruitfly)
anova(lmodh)
lmodu <- lm(log(longevity) ~ activity, fruitfly)
sumary(lmodu)
contr.treatment(4)
contr.helmert(4)
contr.sum(4)
contrasts(sexab$csa) <- contr.sum(2)
sumary(lm(ptsd ~ csa, sexab))
